// -------------------
// FolderBrowseDlg.cpp
// -------------------
/**
* @file
* @brief Re: CAboutDlg, CFolderBrowseDlg
* @author Achim Klein
* @version 0.1
*/


// --------
// Includes
// --------
#include "stdafx.h"
#include "FolderBrowse.h"
#include "FolderBrowseDlg.h"
#include "FolderDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// ---------------------------------
// Definition of the CAboutDlg class
// ---------------------------------
/**
 * 
 */
class CAboutDlg : public CDialog
{

public:

	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL


protected:

	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};


// ---------
// CAboutDlg
// ---------
/**
 * 
 */
CAboutDlg::CAboutDlg()
: CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}


// --------------
// DoDataExchange
// --------------
/**
 * 
 */
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}


// -----------------
// BEGIN_MESSAGE_MAP
// -----------------
/**
 * 
 */
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



// ----------------
// CFolderBrowseDlg
// ----------------
/**
 * 
 */
CFolderBrowseDlg::CFolderBrowseDlg(CWnd* pParent /*=NULL*/)
: CDialog(CFolderBrowseDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFolderBrowseDlg)
	m_folder = _T("");
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


// --------------
// DoDataExchange
// --------------
/**
 * 
 */
void CFolderBrowseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFolderBrowseDlg)
	DDX_Text(pDX, IDC_FOLDER, m_folder);
	//}}AFX_DATA_MAP
}


// -----------------
// BEGIN_MESSAGE_MAP
// -----------------
/**
 * 
 */
BEGIN_MESSAGE_MAP(CFolderBrowseDlg, CDialog)
	//{{AFX_MSG_MAP(CFolderBrowseDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// ------------
// OnInitDialog
// ------------
/**
 * 
 */
BOOL CFolderBrowseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);

	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);

		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	doMoveControls();

	return TRUE;
}


// ------------
// OnSysCommand
// ------------
/**
 * 
 */
void CFolderBrowseDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}

	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


// ------
// OnSize
// ------
/**
 * 
 */
void CFolderBrowseDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	doMoveControls();
}


// ---------------
// OnGetMinMaxInfo
// ---------------
/**
 * 
 */
void CFolderBrowseDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	static CRect rect;

	if (IsWindowVisible())
	{
		if (rect.IsRectEmpty())
		{
			GetWindowRect(rect);
		}

		// min size
		lpMMI->ptMinTrackSize.x = rect.Width();
		lpMMI->ptMinTrackSize.y = rect.Height();

		// max size
		lpMMI->ptMaxTrackSize.y = rect.Height();
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}


// -------
// OnPaint
// -------
/**
 * 
 */
void CFolderBrowseDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);

		CRect rect;
		GetClientRect(&rect);

		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}

	else
	{
		CDialog::OnPaint();
	}
}


// ---------------
// OnQueryDragIcon
// ---------------
/**
 * 
 */
HCURSOR CFolderBrowseDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// --------
// OnBrowse
// --------
/**
 * 
 */
void CFolderBrowseDlg::OnBrowse() 
{
	// create and initialize a new object
	CFolderDlg dlg(TRUE, m_folder, this);

	// set the text that is displayed above the tree view control
	dlg.SetTitle("Any instructions...");

	// show dialog
	if (dlg.DoModal() == IDCANCEL) return;

	// get selected folder
	m_folder = dlg.GetFolderName();

	// show selected folder
	UpdateData(FALSE);
}


// --------------
// doMoveControls
// --------------
/**
 * Moves the controls on sizing.
 */
void CFolderBrowseDlg::doMoveControls()
{
	// get controls
	CWnd* ctrl1 = GetDlgItem(IDC_FOLDER);	if (!ctrl1) return;	// text control
	CWnd* ctrl2 = GetDlgItem(IDC_BROWSE);	if (!ctrl2) return;	// browse button

	// get current rectangles
	CRect cr0;	GetClientRect(cr0);
	CRect cr1;	ctrl1 -> GetWindowRect(cr1);	// text control
	CRect cr2;	ctrl2 -> GetWindowRect(cr2);	// browse button

	// spacings
	int delta = 8;
	int margin = 11;

	// drawing area
	int top = cr0.top + margin;
	int left = cr0.left + margin;
	int right = cr0.right - margin;

	// constant widths
	int cw1 = cr2.Width();	// button

	// constant heights
	int ch1 = cr2.Height();	// button

	// shifting widths
	int sw1 = (right - left - cw1 - delta);	// text control

	// vertical alignment
	int va1 = right - cw1;	// button

	// move controls
	ctrl1 -> MoveWindow( left, top, sw1, ch1 );	// text control
	ctrl2 -> MoveWindow( va1,  top, cw1, ch1 );	// browse button

	// redraw controls
	ctrl2->Invalidate();	// browse button
}
